# coding: utf-8

"""
    Document Intelligence API

    Data APIs to retrieve document intelligence data

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from sema4ai.di_client.document_intelligence_client.models.raw_document_content_all_of_raw_content import RawDocumentContentAllOfRawContent
from typing import Optional, Set
from typing_extensions import Self

class RawDocumentContent(BaseModel):
    """
    RawDocumentContent
    """ # noqa: E501
    document_id: Optional[StrictStr] = None
    content_state: Optional[StrictStr] = None
    raw_content: Optional[List[RawDocumentContentAllOfRawContent]] = None
    __properties: ClassVar[List[str]] = ["document_id", "content_state", "raw_content"]

    @field_validator('content_state')
    def content_state_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Raw']):
            raise ValueError("must be one of enum values ('Raw')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RawDocumentContent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in raw_content (list)
        _items = []
        if self.raw_content:
            for _item_raw_content in self.raw_content:
                if _item_raw_content:
                    _items.append(_item_raw_content.to_dict())
            _dict['raw_content'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RawDocumentContent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "document_id": obj.get("document_id"),
            "content_state": obj.get("content_state"),
            "raw_content": [RawDocumentContentAllOfRawContent.from_dict(_item) for _item in obj["raw_content"]] if obj.get("raw_content") is not None else None
        })
        return _obj


